## mingw-w64-wineditline-2.208-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8.12)
project (WinEditLine)
set (WinEditLine_VERSION_MAJOR 2)
set (WinEditLine_VERSION_MINOR 2)
if (MSVC AND MSVC_USE_STATIC_RUNTIME)
foreach(flag_var
        CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG CMAKE_C_FLAGS_RELEASE
        CMAKE_C_FLAGS_MINSIZEREL CMAKE_C_FLAGS_RELWITHDEBINFO)
   if(${flag_var} MATCHES "/MD")
      string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
   endif(${flag_var} MATCHES "/MD")
endforeach(flag_var)
endif()
if(NOT DEFINED LIB_SUFFIX)
  if(CMAKE_SIZEOF_VOID_P MATCHES 4)
    set(LIB_SUFFIX "32")
  else()
    set(LIB_SUFFIX "64")
  endif()
endif()
configure_file (
  "${PROJECT_SOURCE_DIR}/src/config.h.in"
  "${PROJECT_BINARY_DIR}/config.h"
)
add_subdirectory (src)

=== src/CMakeLists.txt ===
include_directories("${PROJECT_SOURCE_DIR}/src")
include_directories("${PROJECT_BINARY_DIR}")
include(GenerateExportHeader)
add_library(edit_static STATIC editline.c fn_complete.c history.c)
add_library(edit SHARED editline.c fn_complete.c history.c libedit.def)
set_target_properties(edit PROPERTIES PREFIX "")
GENERATE_EXPORT_HEADER(edit
  BASE_NAME edit
  EXPORT_MACRO_NAME edit_EXPORT
  EXPORT_FILE_NAME edit_Export.h
  STATIC_DEFINE edit_BUILT_AS_STATIC
)
add_executable(edit_test libedit_test.c)
target_link_libraries(edit_test edit)
add_executable(edit_test_dll libedit_test_dll.c)
install (TARGETS edit edit_test edit_test_dll
  DESTINATION "${CMAKE_SOURCE_DIR}/bin${LIB_SUFFIX}")
install (TARGETS edit_static
  DESTINATION "${CMAKE_SOURCE_DIR}/lib${LIB_SUFFIX}")
install (FILES editline/readline.h
  DESTINATION "${CMAKE_SOURCE_DIR}/include/editline")
string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
if (MSVC AND uppercase_CMAKE_BUILD_TYPE MATCHES "DEBUG")
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/Debug/edit_static.pdb
    DESTINATION "${CMAKE_SOURCE_DIR}/lib${LIB_SUFFIX}")
  install (FILES ${CMAKE_CURRENT_BINARY_DIR}/Debug/edit.pdb
    DESTINATION "${CMAKE_SOURCE_DIR}/bin${LIB_SUFFIX}")
endif()

=== PKGBUILD ===
# Maintainer: Martell Malone <martellmalone@gmail.com>

_realname=wineditline
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=2.208
pkgrel=1
pkgdesc="An EditLine API implementation for the native Windows Console (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
msys2_references=(
  'aur: mingw-w64-wineditline'
)
msys2_repository_url='https://github.com/ptosco/wineditline/'
license=('spdx:BSD-3-Clause')
url="https://mingweditline.sourceforge.io/"
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
source=("https://github.com/ptosco/wineditline/archive/refs/tags/${_realname}-${pkgver}.tar.gz"
        '001-fix-installing.patch'
        '003-dont-link-with-def.patch'
        '004-add-pkgconfig.patch')
sha256sums=('2df14abed2fadebf6e20bc0853b8b9b01f736ea3a5402420e0192029c6a23d80'
            '821d0a36115832a76497dc6d7ea4b6e45e4ce73621030a59865f851309f8db34'
            '19077726758de7780cd68f3f47d8353516fd864ede1903d55280a1fb3dbe408d'
            '7586c2bfeed3f4ff0998c2958b2613671fbca731768d2d2ac39f91ca28bfca2a')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -p1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd ${_realname}-${_realname}-${pkgver}
  
  apply_patch_with_msg \
    001-fix-installing.patch \
    003-dont-link-with-def.patch \
    004-add-pkgconfig.patch
}

build() {
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -S ${_realname}-${_realname}-${pkgver} \
    -B build-${MSYSTEM}

  cmake --build build-${MSYSTEM}
}

package() {
  DESTDIR=${pkgdir} cmake --install build-${MSYSTEM}

  # Rename the static library
  mv ${pkgdir}${MINGW_PREFIX}/lib/libedit_static.a ${pkgdir}${MINGW_PREFIX}/lib/libedit.a

  sed -i ${_realname}-${_realname}-${pkgver}/${_realname}.pc -e "s,^prefix=\${prefix},prefix=${MINGW_PREFIX}," -e "s,Version: \${version},Version: ${pkgver},"
  install -Dm644 ${_realname}-${_realname}-${pkgver}/${_realname}.pc ${pkgdir}${MINGW_PREFIX}/lib/pkgconfig/${_realname}.pc

  install -Dm644 ${_realname}-${_realname}-${pkgver}/COPYING ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
